Index: Tst/Short/paraplan_s.res.gz.uu
===================================================================
--- Tst/Short/paraplan_s.res.gz.uu	(revision 6d6e14e2098b18d473ba6b37065ba3830d790a35)
+++ Tst/Short/paraplan_s.res.gz.uu	(revision 15bbde9397bbc7cddfd04abf8f047ce99c60ff8d)
@@ -1,42 +1,42 @@
 begin 640 paraplan_s.res.gz
-M'XL("(G9LDP``W!A<F%P;&%N7W,N<F5S`-576V\;QQ5^]Z\8&`&B:$5ESF5N
-M,$P@45O`0.,(<MX*P]A(JX2-1#+<5<W=7]_O+,5=.<V][D,I0:3F<N:<[W)F
-M^>:;O[QZ[9RCI?O[JR_=\Z[MSN]6WSY_\>S-XPPO'0;?K=:K[N2S%\_LW2V7
-M;EOOZNU=O7[7GJ^;]^=M5W?3%EFZZ;.>N\\_YFL*',;`[F\/N^[[9N>:?7V_
-MO6M:=[O9N:YIN]7Z.X<9=U^OUFZ[VUPW-P^[IIWVQ\/^;U;W6-FZS=J]K]_7
-M[DVS[1R7:5GZ7^6?SPWQYT<<F^N'W;^:]B?@ER5.=XL_]SI&(6\UN+\>$'(T
-MC=/YQXC.YVYG8%]=N9?.G[F3_5E_-GQVYFZV4R$$26PW=[V[Q9IT.G!%=-KC
-MKYP.IWU%Z72/?\KI_K1_83E=;]:KZVFS+MU-<^NN+@F[#;`+FSZYA1RQ]M-I
-MY%-WO6OJKKEQ]2&E;O-=,ZKC_:K[WM5KM[IIZCMW]?KBW':^>=AN-ZTM[#</
-MKNNWS<V9:^O^S/WL>3\>SK.U]W7OZNOKIFU'C1W"?MM;#(2S5>.K;;H#-)?T
-MPEU^<?7%Q=>O7UW,J(3E+RZ9/OZ#WKXDKY1:KDKDMJL2B73\9`6_?;E@S>Q;
-M7I!G]A_,RMN73#D53,;B(P*4D@A+CEG$)UE<S<FEY1,$+DVB%R;1_V/8CUG/
-MQ?S>U"W('\O]/P'[;PJ86<G+L;M=XHA[6S74W6JS/KD]PUJ<,YN[_(RV#K+Z
-M547]HIA^4T?LE^Z'U=V=B>CPCF.G2?H8G8SY@T[&4[4L'Z.5L?Z.5L;A22M;
-M4(E!8V35X$MAOP]])9H3L09,)";)WD=*T>^UYSD*3&<!;BLP$4F2IJ(42K#_
-M*`DB22_HDB)"(2HK8=Y[5I\"8G&O<ZQTC!58?,PIQH1=$GWA4'#\O@\54DJ9
-M.$>?,,)92LK9]W&.DI]DY+FDI#F,)^[#4*G&3)JRAFCE,8H9YJWE<>N"64H.
-M'@LR$VE`7<(AHQ8>%B(V#<`R^:2J8LD&12TRQQ)_C$4^2D;^+`"%&(7@8XS[
-M7H>*<LPY4C8%AJ*"K#+WX4D8FL(@"&K.JL47(60^\`(U%`$\22A*\H&#<,R"
-M/(>9(^%C#-142*,PJ2]!I?@0@2XR9P0K+%(T%$%4+A@7B<!NC[*>!),)(\4&
-MSHC#@1FA4@B)"&5QI0E*\E&]PI(I[660.8(>"1(42X$(],:H@6*BZ(F0SB"5
-MEJ3001(O!24!9@Q(VB/5)['"1+:QK3$@;Y"2,B2+PP-RE\IH3!+PFP$@<"H%
-M:_<\S-J36<<IXB>C&F14[!/E8.<.BKF"&,8#RB5E*J+`J?\@4IH8(X'4/)5B
-MF5-B:!:JWP]A09'@A0R<0_8P1BZQ`,9^"'.<2<<02XP%"K(\L`IZ2<$/L^3E
-M\'BE;KVY:=HS1^[KKR[=YM;=/]QU3H_+%,]/]<T_-ZMU]\H:-IHMH]6^LS[*
-M3*`"KJ2,WY+W6IEY&*(#-PP6"T15,24JJ`*D)^@HF7(J"0K`"T,0XIF@%^B2
-M$0:&%U"@%>@#M\`?NBUB<JC@`_;>9)C58Y617C'Z=`)&(YE`V<C^:7@PNH`C
-M/4<0`XVE8ILA7\!=I`04D2`8A6YM4`L:B,`UHB1^U+DF5$5P+CI++OM!H'P0
-M8G)%G\ADZH.1"L@%@0`A#`J4<*$H_!H@6O@'%PJG:)@$<S`,"))]@#?S"`HA
-MPPR]^!P9#$<U6*`GC"%GI!30/WI=@$Q4`A\&<S4<!W`6"C%0A)M@Z.(IR(B.
-M6H.%5J`X%.[1C@P>,G#13=%(<)O!/@:0FC(]1(5>;K9.!X10+CP/.Z`O&PCR
-MB!'N2;@#;H>B@;RA5(DQP=!;@8<CT#>@8(Y@O@(,C`;*:EBA&R<;B2H^)7Z$
-M"]<LSF+T<%_00C.-W9X!5T#RZ(EP***BJ2-""79!P'$!(**=*W)5S6;<B!Y`
-M',AP0?%BA:$A(S,J8ZM89-`"I-&X2K;+PF"QI:`RHP+B"!48*AP`D.)NL:M.
-M^0@*ND&`.N``=#3R(R880&\SD2:0RS)"8GR,0F+KU,6D4RFDE5$-$,7V43P+
-ML"ZXIW`UQ$*/<"B>5:#];'6@61$</28O9KQ#QA%<(<T*IK'*[,M%CM"')51!
-MBH5&^::(J\?(0&\,=AR$GPZ'!!QB).=1+X025`\>`MEY=,XA!XN#2PS#8[6X
-M%/,8O(H!@AN9QA4QDOL8_-A#:'XXFL9X_IZL>("QK]GV/?JA/<&CW"?/_@WQ
-'A!KIG`\`````
+M'XL("+F?$V$"`W!A<F%P;&%N7W,N<F5S`+57:V\;1Q+\[E\Q,`)$T8JZZ<>\
+M8)A`HB2`@8LCR/D6&,9&6B6\DTB&NSIS]]>G>BGNRGE=[LY'"10UCY[NJNJ:
+MY9OOOGSUVCE'2_?W5U^XYUW;G=^M?GC^XMF;QQE>.@R^6ZU7W<EG+Y[97[=<
+MNFV]J[=W]?I=>[YNWI^W7=U-6V3IIL]Z[O[V,5]3X#`&=E\_[+J?FIUK]O7]
+M]JYIW>UFY[JF[5;K'QUFW'V]6KOM;G/=W#SLFG;:'P_[OUO=8V7K-FOWOGY?
+MNS?-MG-<IF7I_Y5_/C?$GQ]Q;*X?=O]JVE^!7Y8XW2W^N]<Q"GFKP7UU0,C1
+M-$[G'R,ZG[N=@7UUY5XZ?^9.]F?]V?#9F;O93H40)+'=W/7N%FO2Z<`5T6F/
+M=SD=3ON*TND>_Y33_6G_PG*ZWJQ7U]-F7;J;YM9=71)V&V`7-GUR"SEB[:?3
+MR*?N>M?477/CZD-*W>;'9E3'^U7WDZO7;G73U'?NZO7%N>U\\[#=;EI;V&\>
+M7-=OFYLSU];]F?O=\WX^G&=K[^O>U=?73=N.&CN$_:&W&`AGJ\97VW0':"[I
+MA;O\_.KSBV]?O[J840G+/UPR??R>WKXDKY1:KDKDMJL2B73\9`6_?;E@S>Q;
+M7I!G]A_,RMN73#D53,;B(P*4D@A+CEG$)UE<S<FEY1,$+DVB%R;1#V"?A_\J
+M]I;7?P;^;X_^7QB8Z\O+T2<N<<2]K1KJ;K59G]R>82W.F=ND+'\OC+W_*3=_
+M2,N_983]TOUS=7=G=!S^XMAIDCZ&)S!_X`D\5<OR,4R!]2^8`H<GIK"@$H/&
+MR*K!E\)^'_I*-"=B#9A(3)*]CY2BWVO/<Q3(UP+<5F`BDB1-12F48/]1$D22
+M7N`W(D(A*BMAWGM6GP)B<:]SK'2,%5A\S"G&A%T2?>%0</R^#Q522IDX1Y\P
+MPEE*RMGW<8Z2GV3DN:2D.8PG[L-0J<9,FK*&:.4QBAGFK>5QZX)92@X>"S(3
+M:4!=PB&C%AX6(C8-P#+YI*IBR09%+3+'$G^,13Y*1OXL`(48A>!CC/M>AXIR
+MS#E2-@6&HH*L,O?A21B:PB`(:LZJQ1<A9#[P`C44`3Q)*$KR@8-PS((\AYDC
+MX6,,U%1(HS"I+T&E^!"!+C)G!"LL4C04050N&!>)P&Z/LIX$DPDCQ0;.B,.!
+M&:%2"(D(97&E"4KR4;VB)5/:RR!S!#T2)"B6`A'HC5$#Q431$R&=02HM2:&#
+M)%X*2@+,&)"T1ZI/8H6);&-;8T#>("5E2!:'!^0NE=&8).`W`T#@5`K6[GF8
+MM2>SCE/$3T8UR*C8)\K!SAT4<P4QC`>42\I41(%3_T&D-#%&`JEY*L4RI\30
+M+%2_'\*"(J$7,G`.V:,Q<HD%,/9#F.-,.H988BQ0D.6!5=!+"GZ8)2^'!Q5U
+MZ\U-TYXY<M]^<^DVM^[^X:YS>ERF>!*I;_ZQ6:V[5V;8,%N&U;XS'V4F4(&N
+MI(S?DO=:6?,P1`=N&"P6B*IB2E10!4A/T%$RY502%(`7AB#$,T$OT"4C#!I>
+M0(%6H`_<`G_HMHC)H4(?L/<FPZP>JXSTBN'3"1B-9`)E(_O7X<'H`AWI.8(8
+M:"P5VPSY`NXB):"(!,$H=&N#6F`@@JX1)?&CSC6A*D+GPEERV0\"Y8,0DRM\
+M(I.I#XU40"X(!`AA4*"$"T71KP&B1?_@0N$4#9-@'8P&!,D^H#?S"`HAPPR]
+M^!P9#$<U6*`GC"%GI!3@'[TN0"8J01\&ZVIT',!9*,1`$=V$ABZ>@HSHJ!DL
+MM`+%H7`/.S)XR,"%F\)(<)NA?0P@-65ZB`I>;FV=#@BA7/0\V@&^;"#((T:X
+M)]$=Z'8H&L@;2I48$PR]%?1P!/H&%)HC6%\!!H:!LAI6<.-D(U'%I\2/<.&:
+MQ5D,#_<%%III='L&7`')PQ/1H8@*4T>$$NR"0,<%@`@[5^2JFJUQ(SR`.)#A
+M@N+%"H,A(S,JHU4L,F@!TC"NDNVR,%AL*:C,J(`X0@6&"@<`I+A;[*I3/H("
+M-PA0!SH`CD9^Q`0#\#83:0*Y+",DQL<H)#:G+B:=2B&MC&J`*+:/XEF`=<$]
+MA:LA%GJ$0_&L`NUGJP-F1>CH,7FQQCMD',$5TJS0-%:9/:;G"'U80A6D6&B4
+M;XJX>HP,>&.PXR#\=#@DX!`C.8]Z(92@>N@AD)W'SCGD8'%PB6%XK!:78AZ#
+M5S%`<"/3N")&<A^#'SV$YH>C:8SG;YR*!QC[PFK?2!_:$SS*??+L%UK6R6'F
+##@``
 `
 end
Index: Tst/Short/paraplan_s.stat
===================================================================
--- Tst/Short/paraplan_s.stat	(revision 6d6e14e2098b18d473ba6b37065ba3830d790a35)
+++ Tst/Short/paraplan_s.stat	(revision 15bbde9397bbc7cddfd04abf8f047ce99c60ff8d)
@@ -1,4 +1,4 @@
-1 >> tst_memory_0 :: 1286789513:3115- 13145 :3-1-1:ix86-Linux:mamawutz:470332 1292524760:3120- 13145 :3-1-2:ix86-Linux:mamawutz:468424
-1 >> tst_memory_1 :: 1286789513:3115- 13145 :3-1-1:ix86-Linux:mamawutz:1458176 1292524760:3120- 13145 :3-1-2:ix86-Linux:mamawutz:1417216
-1 >> tst_memory_2 :: 1286789513:3115- 13145 :3-1-1:ix86-Linux:mamawutz:1605632 1292524760:3120- 13145 :3-1-2:ix86-Linux:mamawutz:1605632
-1 >> tst_timer_1 :: 1286789513:3115- 13145 :3-1-1:ix86-Linux:mamawutz:77 1292524760:3120- 13145 :3-1-2:ix86-Linux:mamawutz:78
+1 >> tst_memory_0 :: 1628676025:4210, 64 bit:4.2.1:x86_64-Linux:nepomuck:449976
+1 >> tst_memory_1 :: 1628676025:4210, 64 bit:4.2.1:x86_64-Linux:nepomuck:2609152
+1 >> tst_memory_2 :: 1628676025:4210, 64 bit:4.2.1:x86_64-Linux:nepomuck:2609152
+1 >> tst_timer_1 :: 1628676025:4210, 64 bit:4.2.1:x86_64-Linux:nepomuck:10