Index: doc/INSTALL_unix.texi
===================================================================
--- doc/INSTALL_unix.texi	(revision a9736bad73426fd324abf87dcf23da6b99a7a8c9)
+++ doc/INSTALL_unix.texi	(revision 17bb2375b205ab1a6e53110eb513bf49d463ab30)
@@ -1,4 +1,4 @@
 @comment -*-texinfo-*-
-@comment $Id: INSTALL_unix.texi,v 1.8 1999-12-08 17:00:39 obachman Exp $
+@comment $Id: INSTALL_unix.texi,v 1.9 1999-12-08 22:54:41 obachman Exp $
 @c FILE: INSTALL_unix.texi
 @c PURPOSE: Installation instruction for Singular on  Unix 
@@ -31,9 +31,9 @@
 archives: 
 @table @code
-@item Singular-@value{VERSION}-share.tgz 
+@item Singular-@value{VERSION}-share.tar.gz 
 contains architecture independent data like documentation and libraries
 (alternatively, you may also download 
 @code{Singular-@value{VERSION}-share.zip}).
-@item Singular-@value{VERSION}-@value{_UNAME}.tgz
+@item Singular-@value{VERSION}-@value{_UNAME}.tar.gz
 contains architecture dependent executables, like the @sc{Singular}
 program.
@@ -86,6 +86,6 @@
 Unpack the archives:
 @smallexample
-gzip -dc Singular-@value{VERSION}-@value{_UNAME}.tgz | tar -pxf -
-gzip -dc Singular-@value{VERSION}-share.tgz | tar -pxf -
+gzip -dc Singular-@value{VERSION}-@value{_UNAME}.tar.gz | tar -pxf -
+gzip -dc Singular-@value{VERSION}-share.tar.gz | tar -pxf -
 @end smallexample
 If you have downloaded @code{Singular-@value{VERSION}-share.zip},
@@ -288,5 +288,5 @@
 @end example
 To fix this, download and install
-@code{Singular-@value{VERSION}-ix86-Linux-static.tgz}.
+@code{Singular-@value{VERSION}-ix86-Linux-static.tar.gz}.
 
 @item For @code{AIX} systems:
Index: doc/README_download.texi
===================================================================
--- doc/README_download.texi	(revision a9736bad73426fd324abf87dcf23da6b99a7a8c9)
+++ doc/README_download.texi	(revision 17bb2375b205ab1a6e53110eb513bf49d463ab30)
@@ -1,4 +1,4 @@
 @comment -*-texinfo-*-
-@comment $Id: README_download.texi,v 1.2 1999-12-08 17:00:39 obachman Exp $
+@comment $Id: README_download.texi,v 1.3 1999-12-08 22:55:54 obachman Exp $
 @c FILE: README_download.texi
 @c PURPOSE: downloading instructions, to be includeded in manual and README_ftp
@@ -18,9 +18,9 @@
 You need to download two (archive) files:
 @table @code
-@item Singular-@value{VERSION}-share.tgz 
+@item Singular-@value{VERSION}-share.tar.gz 
 contains architecture independent data like documentation and libraries
 (alternatively, you may also download 
 @code{Singular-@value{VERSION}-share.zip}).
-@item Singular-@value{VERSION}-<uname>.tgz
+@item Singular-@value{VERSION}-<uname>.tar.gz
 contains architecture dependent executables, like the @sc{Singular}
 program.
@@ -56,6 +56,6 @@
 Unpack the archives:
 @smallexample
-gzip -dc Singular-@value{VERSION}-<uname>.tgz | tar -pxf -
-gzip -dc Singular-@value{VERSION}-share.tgz | tar -pxf -
+gzip -dc Singular-@value{VERSION}-<uname>.tar.gz | tar -pxf -
+gzip -dc Singular-@value{VERSION}-share.tar.gz | tar -pxf -
 @end smallexample
 If you have downloaded @code{Singular-@value{VERSION}-share.zip},
Index: doc/README_ftp.texi
===================================================================
--- doc/README_ftp.texi	(revision a9736bad73426fd324abf87dcf23da6b99a7a8c9)
+++ doc/README_ftp.texi	(revision 17bb2375b205ab1a6e53110eb513bf49d463ab30)
@@ -1,4 +1,4 @@
 @comment -*-texinfo-*-
-@comment $Id: README_ftp.texi,v 1.4 1999-12-08 18:44:10 obachman Exp $
+@comment $Id: README_ftp.texi,v 1.5 1999-12-08 22:55:55 obachman Exp $
 @c FILE: README_download.texi
 @c PURPOSE: This should reside as README file in the main directory of the
@@ -43,8 +43,8 @@
 @nref{INSTALL_unix, INSTALL_unix.html}
 Unix installation instructions
-@item @code{Singular-@value{VERSION}-share.tgz}
+@item @code{Singular-@value{VERSION}-share.tar.gz}
 @sc{Singular} distribution archive which contains architecture
 independent data like documentation and libraries.
-@item @code{Singular-@value{VERSION}-<uname>}.tgz
+@item @code{Singular-@value{VERSION}-<uname>}.tar.gz
 @sc{Singular} distribution archives which contain architecture dependent
 executables, like the @sc{Singular} program.