Index: Singular/ipconv.cc
===================================================================
--- Singular/ipconv.cc	(revision 949d0daf8f79e047555b54805fda181f3f790d51)
+++ Singular/ipconv.cc	(revision 25c6fdd5a0aabb61a69427f7c788f47769760664)
@@ -2,5 +2,5 @@
 *  Computer Algebra System SINGULAR     *
 ****************************************/
-/* $Id: ipconv.cc,v 1.16 1999-01-22 18:23:21 Singular Exp $ */
+/* $Id: ipconv.cc,v 1.17 1999-08-23 16:01:15 Singular Exp $ */
 /*
 * ABSTRACT: automatic type conversions
@@ -181,10 +181,12 @@
 }
 
+static void * iiR2L(void * data)
+{
+  syStrategy tmp=syMinimize((syStrategy)data);
+  (tmp->references)--;
+  return (void *)syConvRes(tmp,TRUE);
+}
+
 #if defined(INIT_BUG) || defined(PROC_BUG)
-static void * iiR2L(void * data)
-{
-  return (void *)syConvRes((syStrategy)data,TRUE);
-}
-
 static void * iiL2R(void * data)
 {
@@ -192,5 +194,4 @@
 }
 #else
-#define iiR2L (iiConvertProc)syConvRes
 #define iiL2R (iiConvertProc)syConvList
 #endif
Index: Tst/Short/string.res.gz.uu
===================================================================
--- Tst/Short/string.res.gz.uu	(revision 949d0daf8f79e047555b54805fda181f3f790d51)
+++ Tst/Short/string.res.gz.uu	(revision 25c6fdd5a0aabb61a69427f7c788f47769760664)
@@ -1,82 +1,82 @@
-begin 644 string.res.gz
-M'XL(",![N3<``W-T<FEN9RYR97,`[1UK;]LX\CM_!6%<`;MA78GR,[X$V';W
-M0X'-88'>AP.R0>'$:N.M;*NRTK5]N/]^0U(4*8E2I-B)'U%0U#(?,\-Y:69$
-M6I___>NG?V&,[4O\^Z</N!$NP[8WO6V,T.>HAUYB:/PRG4_#9FN$V">^%&W+
-M<!P^+-N+AS`>[5SB^+K35M?=-O:#Q1V^6O\13.=A<^)^Q7_?C\-6/*+7QO^-
-MO_3;\!]NL!$:*4/>RAKC-ML6(WT.E4-4$VR'=VI]JJLKYBU#Z/R6F2CPZYVJ
-M;YC&2/"?C3?+/QL:`&JG,!,,0QH*"G6,4/PDE*X!BJ]#Z1NA>$DH0P,43X/B
-M9'C(H8P24)PT+QF4D0ZE:X1"DXQQ^@8P5.>,8^8O32ZJ8V(PU5?5,7,X3((Q
-M<3C4H0"]_XN_#)1V=X!,;[H,L8<OL$TP'<5=7>LRUG,/0#&XZ-J^.4?,T-`U
-M%5<4:8II[-?U#]E$GQ#IDZ$5],,(#&44`#'ZFZS1;A'V05LME!%P&6!4D(*R
-M'6DT2.)!&9ZC]^^Y;>/T'Q"`.:\)7DXW[CG@-]$DN6\K(76I%)(72[3K:-*)
-MQ>/._'#-QR:DHC4GA&&0A$$,VNP\[IL8GC^-\SF?Q]MQU=(12V9U-&:"K3!E
-M]_!9@I^]6MOWJ.U]34`#(:#I?.D&(`R"N7[+WF&!G#3)2Q2`S"D2W2-3MI;F
-M(_#S!"P,@926<S4T)40?$8!VJ0).67(C6?<LI14]N%-ZU[9U`YK1C;6A1[41
-M<*>,Q,44`\1"NG%?Y^E:PY#RR^Y3%$B;G=8ETC5K4Z:]@CYIZ*JH%O_H;J-A
-M^8AC92,HV_>(OHG/[I9Z9UM/6(74G*ZF83VF@\X-=T[A3_>NR:3E*.?4`S?F
-M77?8@,;]5,5GO<%3U8\C0`"2?[N?;J6-1<!2RLF'DOMICH[F=I=6U2):2FNN
-M$@%A_-Y6BRO0))5:,`(!)RHJMT8ZXK2_J*87K53J[%`I?M]BBM]C>LV7TKA?
-M-("V>U=+,?KV[G2\)R[E;-:ZX`U4-;@[-H7*./,LYGY![MW'[,8\:`OKJ4S^
-MDXU,:0!7@-T;W;9+,=@FL!L!O[>V4;5V)!:_9ZNMS"IIK%K<U'>8<0^8<4?V
-MJVSZR6'3DTD=B&_`.V]Z.Q_/7(S/<=3"2F^\Z5Q2%76$:]_E$,Z!H_-O#]XX
-MV(]W>`[JB_V,/PX`9N@&6-8B1QBQB;+JB&6I$6?JBSA55,392B).EP]Q;LT0
-M&PN%AO%^SG@_9[R7,][+&3_*&3_*&4_S%D#S5D#S2*)Y-(4Y$WB1#J%1X(8/
-MP9Q5IE&Y6T<M]Y.7^_-'`\_AKG865S1J%3\U%7^&#.UP-+T@[*PU^=0T^3E2
-MB=KAG9R:[+VLLT?W*'-(K8#:9P74Z?P[_,=*I._#F:^*I'U>/!V((I-JW6'I
-MM#(S^`K/\2^?/W[Z%#7-%A-7\2;B"UM(U++PW3FTS!?1]\`=3_CWD%^NH^:_
-M@VGHZLU[3E?WL]+BU);A*I<,&4>^9/B\'_;M+-1F-MD4YKB_>MZ!<;,@G./J
-M]@P!0$(,QW;CV(_0Y%U">U@QL-J8N14<Q#>1@?9L(I`W$8",\=T]Q%QW$'(!
-M7Z9W@-RAEN6(OOG#[!9BL<57_',<+%F?:.=_M][B[COC'+0O@HG+,4Y\;83Z
-M.^=K7[++%5[C#3;`H3J<CXE[P$$3FG#A34Y4BS179$TV\#GQF_#U8]J9,-,J
-M.]9O'#@'#%ZXD;NXAL&M'M/J:+'H3!ZQB!E5?=M;1M5A,TRZ'.T)R\!IX^G$
-M'7M8Q;4#[='*5+HD]A^L\\)*V+^5-#++8$SI-I^W&323D]&T3'=WA=PD\VQK
-M`EQ500IV-#]_:!$0Q#=W[@;C<!$TESH=DE6002A>0@H1B7?.MJQ2IZ.V`PWZ
-MBJESR50^),%0T9(,/E.#XE#3T.['[08&"]J:O-_$9>-$NLSMR<*LRFHQ.P(O
-M&37063IL8PA/@/WX)[#T>G5F$[R^B;DZU#8"_Y1<7;T%H4%P<[;F%[1U)KXG
-MLQ<&:GV39'6)F9+[)8?R2#]"91")6%LS#YA)2KF(38(K/;@4,57%*P#F$R&%
-M:&L2'](V]A?>&OL@[Q4]6SMG<R5N;6>Q+\4-(V!<UI3T]H24S1.D8/-[_52O
-M09Z,\J8VQB3``A`T38!)3%D<5>7"("302/9J>Y&'W?C1NPI6ASU6!QGR76:J
-MD1='^JQ1DQ18,2O9,'P7^*=J9YOZK[NLT9>-ME6TG;]B<M`5E_KJRB8,_0BF
-MF*32A\.]H8,H.)%?Q$UIMX6:FI.XJ!"D\24J]8CKW)"26(]5C'8!<HO24BUP
-MO%7I*N.8,\6L1+1$"K(/(J/7W9>\:BF;I&PHJ>G6&-?7HJ_Y%HFL[<MO644R
-M5.22NE24RI(X%]IWY:[6/:PJ@[:ESM'9%H2]LS'<:E;P`4N'?RS^9:(D*ZHB
-M)2T`GHV3N3D!-"MY36\NUN*:LO:-O(;V5?*T$<.!&))4*A2A-J4^YBZ_H0,S
-M>%&QOJ901@FD!4I"\W/^"HLRYC]@QHP@9.@WD!0/CJBJ:B61!"GH"*V^`"GC
-MCJ86$(7/%I,'S\6SBVN619)KBZS.-C=*);33@;-TM2:=<0E\@$VV;Z*+9!$"
-MX@H,O``\J<PI"8X4@8GSJ8IS>`E#(\"D2)PCS4<A%Y62RG/&F*.E4*/'IQ40
-MGIW]!-7CH`D.OF-*0`.-=:ORBY;*U==T<<"/N=U$!RUF8X)G+:6&18<?->?^
-M19J$^LJM0GZ-#$-]%;:1O"%\,2TFGF):3WUWVBIUK`5X1`(TWL?)H]Z2/$-R
-MNS_L>AY<:^\1:6]A^ET00I+24<$!YO"UAAZOAJ83#5(B.B0O5FLHSG!(A9#T
-M=*H6M;4=D;5%^86M?G##9C])!GH`JHVO+F[=,)PV9X&[;,Z(U5(9B4U51G(5
-M/W$G%"<B7$Z4S?_/_J0*-M;K,\TLUDC`,>UNX/0VE>5@%O(8*Q\<@[D^:>@H
-M!%YY[X/@JLT+&!R=9*9S&6TIOR(-SO)H![K\LP0#T+O,'Q]EG2<89!@5+L*Q
-MEQPE<7<4;EC$[0M@CE%WV;--7HN[4HI5]'M,!^1;F/AJ]W+<V6XMPV=->"G>
-M<\Z[:P(.-.VMU?AP,E]CI%#GPK7:[D9MGYH.@R<\SHS8;$]UCEQ;X3[2Y+[:
-M2VO;`[FY_R](8#:4K%0.,[S$D#(OO(=PNIC#)=OG"2GT7Y!"QX.HMB\S<&6F
-M$R5)0!K_B[Y9*,#XG^_>X=0'0E9B7#3+01IV=GQJ-IU/9Z"$$[QV$[_*JVX,
-M?-$K)#5F0V,5X3WO-E1N-%[%.N0D^)4*%($CADG$=(JA]&`]`-N>X+R00#JO
-MC;K[&Z#%?9;QAOLB@LRY.P`WD8F=.8<Y$HM&&\U-&Y>-M'57]8=J.2_#(&EK
-M-JLTV'R[=.`J$Z2U"=8F6)O@BYB@>K6&33OQ?KP/3;O==K2[8O>2M;5X5,3.
-M>:F>'NNA<8_:MT?[K,>)>QS5,]"0#ML*6XSBPE9`+Z@"<^'(>8XE"Z31;/8;
-MTX@B-0"<2V1XV@BJ^M6)0)N]AN('#S=^!$#I,IRHI%.KKCO:(<$?QW%P&0;\
-M>%B$4W<>BE/87X/%3`1(2(2G2(2BQW/$N?R2ZL/0Y7E5[=CT2,!HKLG*Y.)/
-MDR>[/6P]0I*%:%7]=O&6NZM38;3TKUW-)?>2;\+Y$1"Q!Y.R:\TG]TN]*.1$
-M&"7C-"W+3Q<=3F2EIDB\%N?1KC2URR"_FDGS^XP;$W8!R?RZGQ/A_.O1L=RL
-M5>S@*AG.D'@.+3VGY#N?3H3/KU:CY(')@F<QM*#W\1=[E0T7"=*5M/2TG;TO
-MJE;IHUVI#)NU$@Q[-Z:\[EBL!N1C_Y[])"C$W+/Q2F@053%W1_O]-AB8/H"W
-MH?$AJW5TW,^!RZBU`U1$K5VXC,X&]C)G-+>'EH@Y-I2L-V1-R6I#5FOS(<_'
-MQOB-79"5^S-0&?1%9_EVAI]&*T>`&P%RM&)/AM>YQT=C6@T3GG)ZU!>Z&NQ@
-M95(]M<I>QU&_O7(_51I<]":5VKL=[TJ[VG.,#8V?@:PWXE(H$K\4BL0OA2+Q
-MRZP?JK7B^%>Z&ZW810Y+RMR'G@MVG>>>QDIWH\Y[3)=)7L!3Y]&UQI;6V"W3
-M<5(EZGW1-)T4!]G;9?'=VJ!.8*6[,2B9#6G/W3J]-G97XYGON7C)U>SKB!'&
-M7CLB&P1=WO06+\/Q?#(.)FWX@G[[SR]7?_S^&R.,4Q]<6+&J3WQV?BWO9WUP
-MT=%&K)X#LGH$8:?2Y*MS\))MUQ!4-1O+\S=+\F:.O7.XFQ'VU)"V1G@Y0LMS
-M<!/0+"R1S4Y-FT/<1;`G1R.VNSA;O\O.HV(>WV?=*IY=\FA,&@GU&'742Z.!
-M]F@;M1%;H\J>[OPMW2V4I@>"R!0ETMK,IF7MWZP2N]\,V['S]F*K[=<XRX91
-MS0;&AEM@PY5@@$;=LQQ/C3U4_S+V4&D'=3C^*>&3DAZ)NR/=&^ECA1N"(7DN
-M*#U8ZF#>E/)^1W<Y28?#O,T+.1NSGWDUUF7V+Z]O^9%?>3FG,E!.Y6O:JWP]
-M'+>BO:X-4NKW[T5#N&![5A</[%5P$;%-;PJI01GODYGPJ`LRSMB='TJ`WZLS
-M2E#R2CU2D@>OTRTE>?#BODF]3<ON6FT<+L,OX('"AR6L8O0/9./+2ZVQS?S`
-*_P%_4-)F@I,`````
+begin 640 string.res.gz
+M'XL("#!HP3<``W-T<FEN9RYR97,`[1UK;]LX\CM_!6%<`;MA78GR,[X$V';W
+M0X'-88'>AP.R0>'4:N.M;*NRTK5]N/]^0U(4*8E2I%B)8U=!4<M\S`SGI9D1
+M:7W\]Z\?_H4QMB_Q[Q_>X5:X#KO>_+8U01^C'GJ)H?'3?#D/VYT)8I_X4K2M
+MPVEXO^ZN[L-XM'.)X^M>5UWWN]@/5I_QU?:/8+X,VS/W"_[[;AIVXA&#+OYO
+M_&78A?]PBXW02!GS5M88M]FV&.ESJ!RBFF`[O%/K4UU],6\=0N?7S$2!7^]4
+M?>,T1H+_;+U:_]G2`%`[A9E@&-)24*ACA.(GH?0-4'P=RM`(Q4M"&1N@>!H4
+M)\-##F62@.*D><F@3'0H?2,4FF2,,S2`H3IG'#-_:7)1/1.#J;ZJGIG#81*,
+MB<.A#@7H_5_\9:2TNP=D>O-UB#U\@6V"Z23NZEN7L9Y[`(K!1=?VS3EBAH:N
+MJ;BB2%-,8[^N?\@F^H1(GPRMH!]&8"BC`(C1WV:-=H>P#]KIH(R`RP"C@A24
+M[4BC01(/RO`<O7W+;1NG_X``S'E-\'J^<\\!OXDFR7U;":E/I9"\6*)]1Y-.
+M+!YWX8=;/C8A%:TY(0R#)`QBT&;G<=_$\/QIG,_Y/-Z/JY:.6#*KIS$3;(4I
+MNX?/$OP<--I^0&T?:@(:"0'-EVLW`&$0S/5;]HX+Y*1)7J(`9$Z1Z!Z8LK<T
+M'X"?)V!A"*2TG*NA*2'ZB`!4IPHX9<F-9#VPE%8,X$[I7=O6#6A&/]:&`=5&
+MP)TR$A=3#!`+Z<=]O<=K#4/*+_N/42!M=EJ72-^L39GV"OJDH:NB6ORCOX^&
+MY2..E8V@;-\#^B8^^WOJG6T]8A52<_J:A@V8#CHWW#F%/]S/;28M1SFG`;@Q
+M[[K'!K3NYBH^&XP>JWX<`0*0_-O=?"]M+`*64DX^E-S-<W0TM[NTJA;14EIS
+ME0@(X_>^6ER!)JG4@A$(.%%1N372$:?]636]:*529\=*\8<64_P!TVN^E-;=
+MJ@6TW;E:BC&TZ]/Q@;B4LUGKBC=0U>#6;`J5<>99S-V*W+D/V8UYT![64YG\
+M1QN9T@"N`/4;W;Y+,=@FL!L!O_>V4;5V)!9_8*NMS"IIK%K<-'28<8^8<4?V
+MJVSZT6'3HTD=B6_`.V]^NYPN7(S/<=3"2F^\Z5Q2%76$6]_E$,Z!H\NO]]XT
+M.(QW>`KJB_V,/PT`9N@&6-8B)QBQB;+JB&6I$6?JBSA55,392B).EP]Q;LT0
+M&PN%AO%^SG@_9[R7,][+&3_)&3_)&4_S%D#S5D#S2*)Y-(4Y$WB1#J%)X(;W
+MP9)5IE&Y6T<C]Y.7^]-'`T_AKFJ+*UJ-BI^:BC]!AO9R-+T@[&PT^=0T^2E2
+MB<;AG9R:'+RL<T#W*'-(K8`Z9`74^?(;_,=*I&_#A:^*I$->/!V)(I-JK;%T
+M6ID9?(7G^)>/[S]\B)H6JYFK>!/QA2TD:EGY[A):EJOH>^!.9_Q[R"^W4?/?
+MP3QT]>8#IZN'66EQ:LMPE4N&C".?,WP^#/MJ"[693;:%.1ZNGO?"N%D0SG%U
+M>X(`("&&8[MQ'$9H\BZA/:P865W,W`H.XIO(2'LV$<B;"$#&^/,=Q%R?(>0"
+MOLP_`W*'6I8C^I;WBUN(Q59?\(]IL&9]HIW_W7JKS]\8YZ!]%<Q<CG'F:R/4
+MWSE?^YI=;O`6[[`!#M7AO$_<`UXTH0D7WN9$=4A[0[9D!Y\SOPU?WZ>="3.M
+MLF/]U@OG@,$+MW(7US*XU6-:'2T6G<DC%C&CJF][S:AZV0R3+D=[PC)RNG@^
+M<Z<>5G'M2'NT,I<NB?T'Z[RP$O9O)8W,,AA3NLWG;0;-Y&2T+=/=72$WR3S;
+MF@!759""'>V/[SH$!/'57;K!-%P%[;5.AV059!"*EY!"1.)=LBVKU.FI[4"C
+MH6+J4C*5#TDP5+0D@\_4H#C4-+3[<;N!P8*V-N\W<=DXD:YS>[(PJ[):S([`
+M2T:-=):.NQC"$V`__@$LO=Z<V01O;V*NCK6-P#\D5S>O06@0W)QM^07MG(GO
+MR>R%@=K>)%E=8J;D?LFA/-*/4!E$(M;6S@-FDE(N8I/@2@\N14Q5\0J`^41(
+M(=J:Q,>TB_V5M\4^R'M#S[;.V5*)6]M9[$MQPP@8ES4EO3TA9?,$*=C\7C_5
+M:Y`GH[RMC3$)L``$31-@$E,61U6Y,`@)-)*]VE[D<3]^]*Z"U?&`U4'&?)>9
+M:N3%D2%KU"0%5LQ*-@S?!?ZAVMFF_NL^:_1EHVT5;>>OF!STQ:6^NK()PS""
+M*2:I].'EWM!!%)S(3^*F5&^AIN$D+BH$:7R)2CWB.C>D)-9#%:,Z0.Y16FH$
+MCO<J764<<Z:8E8B62$'V063T6G_)JY&R2<J&DIINC7%]+?J:;Y'(VK_\EE4D
+M0T4NJ4M%J2R)<Z%#5^X:W<.J,FA;ZAR=;4'8NYC"K68#'[!T^,?B7R9*LJ$J
+M4M("X,4TF9L30+.1U_3F8BNN*6O?R6MHWR1/&S$<B"%)I4(1:E/J8^[R6SHP
+M@Q<5ZVL+991`.J`D-#_GK[`H8_X#9LP(0H9^`TGQX(BJJE8229""CM#J"Y`R
+M[FEJ`5'X8C6[]UR\N+AF622YMLCF;'>C5$([';A(5VO2&9?`!]AD^RZZ2!8A
+M(*[`P`O`D\J<DN!($9@XGZHXAY<P-`),BL0YTGX0<E$IJ3QGC#E:"C5Z>%H!
+MX=G9CU`]#IK@X!NF!#306+<JOVBI7$--%T?\F-M-=-!B,25XT5%J6'3X47/N
+MGZ1)J*_<*N37R##45V$;R1O")]-BXBFF]31WI[U2QT:`1R1`XWV</.@MR1,D
+MMX?#KN?!C?8>D?86IM\%(20I'16\P!R^T=#CU=!THD%*1(?DV6H-Q1D.J1"2
+MGD[5HK&V([*V*+^PU0]NV.PGR4`/0+7QU<6M&X;S]B)PU^T%L3HJ([&IRDBN
+MXB?NA.)$A,N)LOG_V9]4P<9Z?::9Q1H).*;=#9S>MK(<S$(>8^6#8S#7)PT=
+MA<`K[WT07+5Y`8.CD\QT+J,MY5>DQ5D>[4"7?Y9@`'J3^>.CK/,$@PRCPE4X
+M]9*C).Z>P@V+N'T&S#'J/GNVR6MQ5TJQBGZ/Z07Y%B:^QKT<=[;;R/!)$UZ*
+M#YSSUDW`"TU[&S5^.9FO,5)H<N%&;>M1V\>FP^`)CS,C-MM3DR,W5GB(-'FH
+M]M+:]DAN[O\+$I@=)1N5PXPO,:3,*^\^G*^6<,GV>4(*_1>DT/$@JNW+#%R9
+MZ41)$I#&_Z)O%@HP_N>;-SCU@9"5&!?-<I"&G1V?6LR7\P4HX0QOW<2O\JH;
+M`U_T!DF-V=%817C/FQV5&XTWL0XY"7ZE`D7@B&$2,9UB*#U8#\#V)S@O))#.
+M:Z?N_@9H<9]EO.'6),B\&P`P#)DXEG->([$NM-,\L7%E2%M:59>G5*\V'DB+
+ML5F]P.:;G@-7&1)]0D-J;*6QE:.T%?4F"YOVXNUO[]IVM^MH-Z'^)6OK\""$
+M':M2/0/60^,>M4V.#EF/$_<XJF>D(1UW%;88Q86M@%Y0!>;"D?,<2]8CH]GL
+M)YT116H`>('(?+015/6K`W@V>^O#=WYW_QX`I>MPIG(\K9CM:&?ROA_'.6$8
+M\/U^%<[=92@./7\)5@L1CR`1#2(1^1W/B>+R2VK.'I?G5;53RA,!H[TE&Y.C
+M/DV>U'NV>8(D"]&F^AWA-7=7I\)HZ5_[FDL>)%\\\ST@8LLC9=>:3QZ6>B_'
+MB3!*1EM:4IW.\4]DI:9XNA'GT:XT]5`_OWA(\_N,^P#J@&1^N\Z)</[GT;'<
+MW%-LF"H9SI!X#BT]I^0KEDZ$SS^M1LGSB06//FA![\/OT2H;+A*D*VGI:;6]
+MGJE1Z:-=J0R;M1(,>Q6EO.Y9K`;D8_^._0(GQ-R+Z49H$%4Q=T_[N308F#[O
+MMJ/QF:9M=+K.@<NHM0=41*U]N(R.X@TR1R+WAY:(.7:4;'=D2\EF1S9;\YG*
+MA\;XK3K(ROW5I0SZHJ-SM>&GT<H1X$:`'&W8@]AM[FG-F%;#A,<<UO2%K@8U
+MK$RJIU;9ZSGJIT[NYDJ#BUY<TGBWXUUI7WL:L:/QDXSM3EP*1>*70I'XI5`D
+M?IGU0XU6'/]*Z]&*.G)84N8^]%2PFSSW-%9:CSH?,%TF>0%/DT<W&EM:8_=,
+MQTF5J/=9TW12'&3OE\7W&X,Z@9768U`R&]*>N_4&7>QNI@O?<_&:J]F7"2.,
+MO>5#-@BZO/DM7H?3Y6P:S+KP!?WVGU^N_OC]-T88ISZXL&)5G_GLN%C>K^C@
+MHI.$6#T'9/4(P@Z!R3?5X#7;KB&H:K?6YZ_6Y-42>^=P-R/LJ2'M3/!Z@M;G
+MX":@65@BFYV:MH2XBV!/CD9L,V^V?I>=1\4\OJVY4SR[Y$F4-!+J,>JHET8#
+M[=&N92.V5I4MU/D[J#LH30\$D2E*I+693<LZO%DE]K`9=C_G;7U6NYUQE@V3
+MA@V,#;?`ABO!`(VZ)SD-&GNHX67LH=(.ZN7XIX1/2GHD[HYT;Z2/%6X(AN2Y
+MH/1@J8-Y4\K['=WE)!T.\S;/Y&S,?N:GL2ZS?_GYEA_YE>=S*B/E5+ZDO<J7
+ME^-6M+>C04K]]JUH"%=LS^KJGKUY+2*V[<TA-2CC?3(3'G1!QAGU^:$$^(,Z
+MHP0E/ZE'2O+@YW1+21X\NV]2+Z^R^U87A^OP$WB@\'X-JYC\`]GX\E)K[#(_
+*\'\UM<T[\9(`````
 `
 end
Index: Tst/Short/string.stat
===================================================================
--- Tst/Short/string.stat	(revision 949d0daf8f79e047555b54805fda181f3f790d51)
+++ Tst/Short/string.stat	(revision 25c6fdd5a0aabb61a69427f7c788f47769760664)
@@ -1,11 +1,11 @@
 Status Output of tst_status.out
-init >> USER    :siebert
-init >> HOSTNAME:pitti
-init >> uname -a:Linux pitti 2.0.35 #130 Mon Jul 27 11:06:31 MEST 1998 i586 unknown
-init >> date    :Tue Aug 17 17:11:59 MEST 1999
+init >> USER    :hannes
+init >> HOSTNAME:nepomuck.mathematik.uni-kl.de
+init >> uname -a:Linux nepomuck.mathematik.uni-kl.de 2.0.33 #1 Wed Jan 21 18:50:57 MET 1998 i686 unknown
+init >> date    :Mon Aug 23 17:26:39 MET DST 1999
 init >> version :1304
 init >> ticks   :100
-1 >> tst_memory_0 :: pitti:287246
-1 >> tst_memory_1 :: pitti:351570
-1 >> tst_memory_2 :: pitti:270336
-1 >> tst_timer_1 :: pitti:28
+1 >> tst_memory_0 :: nepomuck.mathematik.uni-kl.de:288184
+1 >> tst_memory_1 :: nepomuck.mathematik.uni-kl.de:352080
+1 >> tst_memory_2 :: nepomuck.mathematik.uni-kl.de:274432
+1 >> tst_timer_1 :: nepomuck.mathematik.uni-kl.de:33